package org.eclipse.example;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.henshin.interpreter.EGraph;
import org.eclipse.emf.henshin.interpreter.Engine;
import org.eclipse.emf.henshin.interpreter.UnitApplication;
import org.eclipse.emf.henshin.interpreter.impl.EGraphImpl;
import org.eclipse.emf.henshin.interpreter.impl.EngineImpl;
import org.eclipse.emf.henshin.interpreter.impl.UnitApplicationImpl;
import org.eclipse.emf.henshin.interpreter.util.InterpreterUtil;
import org.eclipse.emf.henshin.model.Module;
import org.eclipse.emf.henshin.model.Unit;
import org.eclipse.emf.henshin.model.resource.HenshinResourceSet;

/**
 * @author spasero
 *
 */
public class Left2Right {

	public static void main(String[] args) {
		System.out.println("Generating Right model for 'example-left.xmi'...");
		// Load the transformation module and the input model:
		HenshinResourceSet resourceSet = new HenshinResourceSet("src/org/eclipse/example");
		Module module = resourceSet.getModule("left2right.henshin", false);
		Resource exampleLeft = resourceSet.getResource("example-left.xmi");
		// Initialize the Henshin graph:
		EGraph graph = new EGraphImpl(exampleLeft);
		// Initialize the interpreter:
		Engine engine = new EngineImpl();
		Unit unit = module.getUnit("doTransfo");
		UnitApplication unitApp = new UnitApplicationImpl(engine, graph, unit, null);
		// Execute the transformation unit:
		InterpreterUtil.executeOrDie(unitApp);
		EObject result = (EObject)unitApp.getResultParameterValue("result");
		resourceSet.saveEObject(result, "model_right.xmi");
		System.out.println("Right model generated !");
	}
}
